# -*- encoding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2010-2012 E.Samyn - esamyn@gmail.com
# Author: E.Samyn
#
# This file is part of the project_load_planning module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU Affero General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program; 
# If not, see <http://www.gnu.org/licenses/> or  write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from mx import DateTime
import time

from osv import fields, osv

class task(osv.osv):
	_name = "project.task"
	_description = "Task"
	_inherit = "project.task"		
	_columns = {'load_ids' : fields.one2many('project.load', 'task_id', 'Loads'),
	}
task()

#-----
class project_load(osv.osv):
	_name = "project.load"
	_description = "load planning"	
	
#	def _get_analytic_account(self,cr,uid,ids,field_name,arg,context):
#		res = {}
#		load = self.browse(cr, uid, ids)[0]
#		try:
#		res[load.id] = load.
#		return res
		
		
	_columns = {
		'task_id': fields.many2one('project.task', 'Task', ondelete='cascade'),	
		'analytic_account_id': fields.related('task_id','project_id', 'analytic_account_id',type='many2one', relation='account.analytic.account', store=True,string='Analytic account'),#fields.function(_get_analytic_account,method=True,string='Analytic account',type='many2one',relation="account.analytic.account",store=True,readonly=True, help="analytic account");
		
		'manager_id': fields.related('project_id', 'analytic_account_id', 'user_id', type='many2one', relation='res.users', string='Project Manager'),
		
		'name' : fields.many2one('project.load_period','Period',required=True),
		'user' : fields.many2one('res.users', 'User'),
		'planned_hours' : fields.float('Planned hours', digits=(12,2)),
		# 'planned_days' fields.function(_get_cost_min,method=True,string='Cost min',type='float',store=True,readonly=True, help="Sum of min cost"),
		'real_hours' : fields.float('Real hours', digits=(12,2)), # TODO : fields.function() calculate from task.work
		# 'real_days'
		# 'available_hours_for_user'
		# 'available_days_for_user'
		'state' : fields.selection([('draft','Draft'),
									('done','Done'),
                        			('canceled','Canceled'),], 'State'),
	}
	_defaults={
          'state': lambda *a: 'draft',
	}
#	_order = 'sequence,name asc'
  
project_load()

#-----
# TODO : See if relevant to replace by accounting periods ???
class load_period(osv.osv):
	_name = "project.load_period"
	_description = "load period for load planning"	
	_columns = {
		'name' : fields.char("Title", size=250, required=True),
		'start_date' : fields.date('Start date'),
		'end_date' : fields.date('End date'),
		'state' : fields.selection([('draft','Draft'),
									('done','Done'),
                        			('canceled','Canceled'),], 'State'),
	}
	_defaults={
          'state': lambda *a: 'draft',
	}
	_order = 'start_date asc'
  
load_period()
